%global name qlcplus
# This is the name of the github repo
%global github mcallegari/qlcplus
# This is the git tag in the github repo
%global version QLC+_4.14.1
# This is the version in X.Y.Z format
%global short_version 4.14.1

Name: %{name}
Summary: Q Light Controller Plus - The free DMX lighting console
Version: %{version}
Release: 1
License: Apache License, Version 2.0
URL: https://github.com/%{github}
# E.g. https://github.com/mcallegari/qlcplus/archive/QLC+_4.14.1.tar.gz
Source0: %{url}/archive/%{version}.tar.gz
# PR: https://github.com/mcallegari/qlcplus/pull/1636
Patch0: 0001-e131controller.h-Fix-QT-includes.patch
#Patch0: 0001-variables.cmake-Replace-hard-coded-QT-version-in-PLU.patch
#Patch1: 0002-variables.cmake-Set-LIBSDIR-to-CMAKE_INSTALL_LIBDIR.patch
#Patch2: 0003-resources-Add-docs-subdirectory-to-CMakeLists.txt.patch
#Patch3: 0004-velleman-Install-only-on-Windows-where-we-have-real-.patch

BuildRequires: gcc-c++ pkg-config desktop-file-utils
#BuildRequires: qt5-qtbase-devel qt5-qttranslations qt5-qtconfiguration-devel
#BuildRequires: qt5-qtmultimedia-devel qt5-qtscript-devel qt5-linguist
#BuildRequires: qt5-qtserialport-devel qt5-qtwebsockets-devel
BuildRequires: qt6-qtbase-devel qt6-qttranslations qt6-qtmultimedia-devel
BuildRequires: qt6-qttools-devel qt6-qtsvg-devel qt6-linguist
BuildRequires: qt6-doctools qt6-designer qt6-qtserialport-devel qt6-qtwebsockets-devel
BuildRequires: qt6-qt3d-devel qt6-qtsvg-devel
BuildRequires: libusb1-devel libftdi-devel alsa-lib-devel
BuildRequires: libudev-devel fftw3-devel
BuildRequires: libsndfile-devel libmad-devel dos2unix

#Requires: qt5-qtbase qt5-qtscript qt5-qtmultimedia
Requires: qt6-qtbase qt6-qttranslations qt6-qtmultimedia
Requires: qt6-qttools qt6-qtsvg qt6-linguist
Requires: qt6-doctools qt6-qtserialport qt6-qtwebsockets
Requires: qt6-qt3d qt6-qtsvg
Requires: libusb1 libftdi alsa-lib
Requires: fftw3
Requires: libsndfile libmad

%description
QLC+ is a fork of the great QLC project written
by Heikki Junnila. This project aims to continue
the development of QLC and to introduce new features.
The primary goal is to bring QLC+ at the level
of other lighting control commercial softwares.

%prep
%autosetup -n %{name}-QLC-_%{short_version} -p 1

%build
# We need to build in-tree (otherwise the build fails)
# We also build a static library, so we need to override Fedora's enforcement
%cmake -B . -DBUILD_SHARED_LIBS:BOOL=OFF -DCMAKE_BUILD_TYPE=Release -DCMAKE_PREFIX_PATH=/usr/lib64/cmake/Qt6 .
%make_build

%install
INSTALL_ROOT=%{buildroot} %make_install

%files
%license COPYING
%{_mandir}/man1/qlcplus-fixtureeditor.1.gz
%{_mandir}/man1/qlcplus.1.gz

%{_bindir}/qlcplus
%{_bindir}/qlcplus-fixtureeditor

%{_libdir}/libqlcplusengine.so
%{_libdir}/libqlcplusui.so
%{_libdir}/libqlcpluswebaccess.so

%{_datadir}/mime/packages/qlcplus.xml
%{_datadir}/qlcplus/fixtures/*
%{_datadir}/qlcplus/inputprofiles/*
%{_datadir}/qlcplus/rgbscripts/*
%{_datadir}/qlcplus/Sample.qxw
%{_datadir}/qlcplus/gobos/*
%{_datadir}/qlcplus/miditemplates/*
%{_datadir}/qlcplus/modifierstemplates/*
%{_datadir}/qlcplus/translations/*
%{_datadir}/qlcplus/web/*
%{_datadir}/applications/*
%{_datadir}/metainfo/*
%{_datadir}/pixmaps/*

%{_libdir}/qt6/plugins/qlcplus/audio/libmadplugin.so
%{_libdir}/qt6/plugins/qlcplus/audio/libsndfileplugin.so
%{_libdir}/qt6/plugins/qlcplus/libartnet.so
%{_libdir}/qt6/plugins/qlcplus/libdmx4linux.so
%{_libdir}/qt6/plugins/qlcplus/libdmxusb.so
%{_libdir}/qt6/plugins/qlcplus/libe131.so
%{_libdir}/qt6/plugins/qlcplus/libenttecwing.so
%{_libdir}/qt6/plugins/qlcplus/libhidplugin.so
%{_libdir}/qt6/plugins/qlcplus/libloopback.so
%{_libdir}/qt6/plugins/qlcplus/libmidiplugin.so
%{_libdir}/qt6/plugins/qlcplus/libos2l.so
%{_libdir}/qt6/plugins/qlcplus/libosc.so
%{_libdir}/qt6/plugins/qlcplus/libpeperoni.so
%{_libdir}/qt6/plugins/qlcplus/libspi.so
%{_libdir}/qt6/plugins/qlcplus/libudmx.so

%{_sysconfdir}/udev/rules.d/z65-anyma-udmx.rules
%{_sysconfdir}/udev/rules.d/z65-dmxusb.rules
%{_sysconfdir}/udev/rules.d/z65-fx5-hid.rules
%{_sysconfdir}/udev/rules.d/z65-peperoni.rules
%{_sysconfdir}/udev/rules.d/z65-spi.rules

%changelog
* Fri Apr 6 2025 Christoph Müllner <christophm30@gmail.com> - 4.14.1-1
- Bump QLC+ to 4.14.1 and adding translations.

* Fri Mar 7 2025 Christoph Müllner <christophm30@gmail.com> - 4.14.0-2
- Add support for Briteq Theatre 250EZ

* Wed Feb 19 2025 Christoph Müllner <christophm30@gmail.com> - 4.14.0-1
- Bump QLC+ to 4.14.0.

* Wed Nov 6 2024 Christoph Müllner <christophm30@gmail.com> - 4.13.1-2
- Switch from qt-make to cmake.
- Switch from Qt5 to Qt6.

* Fri Oct 11 2024 Christoph Müllner <christophm30@gmail.com> - 4.13.1-1
- Bump QLC+ to 4.13.1.

* Sat Jun 3 2023 Christoph Müllner <christophm30@gmail.com> - 4.12.7-1
- Bump QLC+ to 4.12.7.

* Tue Sep 20 2022 Christoph Müllner <christophm30@gmail.com> - 4.12.6-1
- Bump QLC+ to 4.12.6.

* Tue Aug 31 2021 Christoph Müllner <christophm30@gmail.com> - 4.12.4-1
- Bump QLC+ to 4.12.4.

* Sat Dec 26 2020 Christoph Müllner <christophm30@gmail.com> - 4.12.3-1
- Initial release based on QLC+ to 4.12.3 with Qt5 and built with qmake.
